import type { KitEvent, KitResponse } from './index.js';
import { InternalServerError } from './http.js';
type Fn<KitEv extends KitEvent, TLocals, R, TReturn extends KitResponse | void> = (event: {
    locals: Flat<TLocals>;
} & KitEv, n: R) => TReturn | void;
/**
 * @example
 * export async function POST<const Request extends Post>(event: KitEvent<Request>) {
 * 	return endpoint(event)(
 * 		authGuard('admin'),
 * 		validateBody(UserSchema),
 * 		(event) => {
 * 			// ... Do stuff
 * 			return Ok({
 * 				body: {
 * 					...
 * 				}
 * 			})
 * 		}
 * 	)
 * }
*/
export declare function endpointPipe<KitEv extends KitEvent, TFallback extends () => KitResponse = never>(event: KitEv, fallbackResponse?: TFallback): <_A extends void | KitResponse = void, _B extends void | KitResponse = void, _C extends void | KitResponse = void, _D extends void | KitResponse = void, _E extends void | KitResponse = void, _F extends void | KitResponse = void, _G extends void | KitResponse = void, _H extends void | KitResponse = void, _I extends void | KitResponse = void, _J extends void | KitResponse = void, _K extends void | KitResponse = void, _L extends void | KitResponse = void, _M extends void | KitResponse = void, _N extends void | KitResponse = void, _O extends void | KitResponse = void, _P extends void | KitResponse = void, _Q extends void | KitResponse = void, _R extends void | KitResponse = void, _S extends void | KitResponse = void, _T extends void | KitResponse = void, A = {}, B = {}, C = {}, D = {}, E = {}, F = {}, G = {}, H = {}, I = {}, J = {}, K = {}, L = {}, M = {}, N = {}, O = {}, P = {}, Q = {}, R_1 = {}, S = {}, T = {}>(fn1: Fn<KitEv, {}, A, _A>, fn2?: Fn<KitEv, A, B, _B> | undefined, fn3?: Fn<KitEv, A & B, C, _C> | undefined, fn4?: Fn<KitEv, A & B & C, D, _D> | undefined, fn5?: Fn<KitEv, A & B & C & D, E, _E> | undefined, fn6?: Fn<KitEv, A & B & C & D & E, F, _F> | undefined, fn7?: Fn<KitEv, A & B & C & D & E & F, G, _G> | undefined, fn8?: Fn<KitEv, A & B & C & D & E & F & G, H, _H> | undefined, fn9?: Fn<KitEv, A & B & C & D & E & F & G & H, I, _I> | undefined, fn10?: Fn<KitEv, A & B & C & D & E & F & G & H & I, J, _J> | undefined, fn11?: Fn<KitEv, A & B & C & D & E & F & G & H & I & J, K, _K> | undefined, fn12?: Fn<KitEv, A & B & C & D & E & F & G & H & I & J & K, L, _L> | undefined, fn13?: Fn<KitEv, A & B & C & D & E & F & G & H & I & J & K & L, M, _M> | undefined, fn14?: Fn<KitEv, A & B & C & D & E & F & G & H & I & J & K & L & M, N, _N> | undefined, fn15?: Fn<KitEv, A & B & C & D & E & F & G & H & I & J & K & L & M & N, O, _O> | undefined, fn16?: Fn<KitEv, A & B & C & D & E & F & G & H & I & J & K & L & M & N & O, P, _P> | undefined, fn17?: Fn<KitEv, A & B & C & D & E & F & G & H & I & J & K & L & M & N & O & P, Q, _Q> | undefined, fn18?: Fn<KitEv, A & B & C & D & E & F & G & H & I & J & K & L & M & N & O & P & Q, R_1, _R> | undefined, fn19?: Fn<KitEv, A & B & C & D & E & F & G & H & I & J & K & L & M & N & O & P & Q & R_1, S, _S> | undefined, fn20?: Fn<KitEv, A & B & C & D & E & F & G & H & I & J & K & L & M & N & O & P & Q & R_1 & S, T, _T> | undefined) => Promise<NonNullable<_A | _B | _C | _D | _E | _F | _G | _H | _I | _J | _K | _L | _M | _N | _O | _P | _Q | _R | _S | _T | (TFallback extends never ? any : ReturnType<TFallback>)>>;
export {};
